char ACK[] = {0x00,0x00,0xFF,0x00,0xFF,0x00};
char NAK[] = {0x00,0x00,0xFF,0xFF,0x00,0x00};

char CMD_SYNC_PDC[] = {0x55,0x55,0x55,0x55,0x00,0x00,0x00,0x00};
char CMD_PREA_PDC[] = {0x00,0x00,0xFF,0xFF,0xFF};    
char CMD_MXRC_PDC[] = {0xD4,0x32,0x01,0x02};
char CMD_MXRT_PDC[] = {0xD4,0x32,0x05,0x02,0x02,0x05};
char CMD_ASBA_PDC[] = {0xD4,0x32,0x0A,0x59,0xF4,0x3F,0x11,0x4D,0x85,0x61,0x6F,0x26,0x62,0x8F};
char CMD_ASB2_PDC[] = {0xD4,0x32,0x0B,0x5F,0xFF,0x3F,0x11,0x4D,0x85,0x61,0x6F};
char CMD_ASBB_PDC[] = {0xD4,0x32,0x0C,0xFF,0x17,0x75};
char CMD_ASB8_PDC[] = {0xD4,0x32,0x0D,0x75,0x15,0x8A,0x75,0x08,0xB2,0x75,0x01,0xD1};
char CMD_SUMC_PDC[] = {0xD4,0x14,0x01,};
char CMD_LIST_FLC[] = {0xD4,0x4A,0x01,0x01,0x00,0xFF,0xFF,0x00,0x00};
char CMD_LIST_MIF[] = {0xD4,0x4A,0x01,0x00};
char CMD_LIST_TYB[] = {0xD4,0x4A,0x01,0x03,0x00,0x00};
char CMD_TYPB_REL[] = {0xD4,0x52,0x01};

char	m_cSendBuf[64];
char	m_cRecvBuf[256];
char 	g_strLastReadId[16];
int		g_nLasrReadLen;
int		rlength;
int		sopen;
int   pwmonitor = 50;
int   pwselect = 52;
int   pwselect2 = 53;

void setup() {
  //PowerMonitor Select port initialize
    pinMode(pwmonitor, INPUT);
    pinMode(pwselect, INPUT);
    pinMode(pwselect2, INPUT);
	// UDOO initialize serial port at a baud rate of 115200 bps
	Serial.begin(115200);
	// Card Reader initialize serial port at a baud rate of 115200 bps
	Serial1.begin(115200,SERIAL_8N1);
	//Serial.println("start");
	sopen = 1;
}

/******************************************************************************/
/*                                                                            */
/******************************************************************************/

/*----------------------------------------------------------------------------*/
/*  BYTE ins:Command Byte                                           */
/*  BYTE p1:Parameter1 Byte                                         */
/*  BYTE p2:Parameter2 Byte                                         */
/*  BYTE p3:Parameter3 Byte                                         */
/*  BYTE len:data length                                            */
/*  LPBYTE data:data buffer                                         */
/*----------------------------------------------------------------------------*/
int SendCmdInOut(char *cmd, int len)
{
	int pos, i, dlen;
	int ret, step;
	byte bcc;
	unsigned long start;
	unsigned long m_ulTimeOut;

	ret = -1;		//time out
	step = 0;
	dlen = 0;
	m_ulTimeOut = 2000000; //2sec

	//Sync Data
	m_cSendBuf[0] = 0x00;
	m_cSendBuf[1] = 0x00;
	m_cSendBuf[2] = 0xff;
	m_cSendBuf[3] = 0xff;
	m_cSendBuf[4] = 0xff;
	m_cSendBuf[5] = 0x00;
	m_cSendBuf[6] = len;
	m_cSendBuf[7] = 0 - len;

	i = 0;
	for (pos = 8; pos < (len + 8); pos++) {
		m_cSendBuf[pos] = cmd[i++];
	}

	bcc = 0;
	// Calculate BCC
	for (pos = 8; pos < (len + 8); pos++) {
		bcc += m_cSendBuf[pos];
	}
	m_cSendBuf[pos] = 0 - bcc;
	pos++;
	m_cSendBuf[pos] = 0x00;
	pos++;

	//*********************For Debug
	//Serial.println("Send Data");
	//for(i = 0; i < pos; i++) {
	//	Serial.print(m_cSendBuf[i],HEX);
	//	Serial.print(" ");
	//}
	//Serial.print("\n");
	//*********************Debug End

	//Send Sync Data
	Serial1.write(CMD_SYNC_PDC, 8); 
	//Send Command Data
	Serial1.write(m_cSendBuf, pos);
	//Timer Start
	start = micros();

	//Recieve Data
	pos = 0;
	while( m_ulTimeOut > (abs(micros() - start))) {
		if (Serial1.available() > 0) {
			m_cRecvBuf[pos] = Serial1.read();
			pos++;
			switch(step) {
				//Wait for ACK,NACK Flame
				case 0:
					//Normal End
					if( m_cRecvBuf[0] == 0x00 ) {
						step++;
					}
					else  {
						ret = -2;	//command error
					}
					break;
				//Confirm ACK,NACK
				case 1:
					if (pos >=4 ) {
						//ACK
						if( m_cRecvBuf[3] == 0x00 ) {
							step++;
						}
						//NACK
						else  {
							ret = -2;	//command error
						}
					}
					break;
				//Get Data Length
				case 2:
					if (pos >=10 ) {
						dlen = m_cRecvBuf[9];
						step++;
					}
					break;
				//Save it
				case 3:
					if (pos == dlen + 13)
						step++;
					break;
			}
			if (step == 4) {
				ret = 0;
				//Send ACK
				Serial1.write(ACK, 6); 
				break;
			}
		}
	}
	//*********************For Debug
	//if (ret == 0) {
	//	Serial.println("Recieve Data");
	//	for (i = 0; i < pos; i++) {
	//		Serial.print(m_cRecvBuf[i], HEX);
	//		Serial.print(" ");
	//	}
	//	Serial.print("\n");
	//}
	//*********************Debug End
	rlength = pos;
	return ret;
}

/******************************************************************************/
/*                                                                            */
/******************************************************************************/
int RW_open()
{
	int status;
	
	//MaxRetries
	status = SendCmdInOut(CMD_MXRT_PDC, 6);
	if (status != 0)
		return status;
	//Analog setting for the baudrate 106 kbps typeA
	status = SendCmdInOut(CMD_ASBA_PDC, 14);
	if (status != 0)
		return status;
	//Analog setting for the baudrate 212/424 kbps
	status = SendCmdInOut(CMD_ASB2_PDC, 11);
	if (status != 0)
		return status;
	//Analog setting for the baudrate typeB
	status = SendCmdInOut(CMD_ASBB_PDC, 6);
	if (status != 0)
		return status;
	//Analog setting for the baudrate 212/424 and 848 kbps
	status = SendCmdInOut(CMD_ASB8_PDC, 12);
	if (status != 0)
		return status;
	//MaxRtyCOM
	status = SendCmdInOut(CMD_MXRC_PDC, 4);
	if (status != 0)
		return status;
	//SAMConfiguration
	status = SendCmdInOut(CMD_SUMC_PDC, 3);
	return status;
}

/******************************************************************************/
/*                                                                            */
/******************************************************************************/
void loop() {

	int status;
	int pos;
	int count;
	char mode;

	while(1) {
		if (Serial.available()) {
    		mode = Serial.read();
			switch (mode) {
				//Felica
				case '0':
					status = SendCmdInOut(CMD_LIST_FLC, 9);
					break;
				//Mifare
				case '2':
					status = SendCmdInOut(CMD_LIST_MIF, 4);
					break;
				//TypeB
				case '3':
					status = SendCmdInOut(CMD_TYPB_REL, 3);
					status = SendCmdInOut(CMD_LIST_TYB, 6);
					break;
				//Initialize
				case 'O':
					if (sopen == 0) {
						Serial1.begin(115200);
						sopen = 1;
					}
					if (RW_open() == 0) {
						m_cRecvBuf[0] = 0;
					}
					else {
						m_cRecvBuf[0] = 1;
					}
					rlength = 1;
					status = 0;
					break;
				//Close
				case 'C':
					Serial1.end();
					m_cRecvBuf[0] = 0;
					rlength = 1;
					status = 0;
					sopen = 0;
					break;
			}
			//Recive Normal End
			if (status == 0) {
				Serial.write(m_cRecvBuf, rlength);
			}
		}
	}
}
