#! /bin/bash
# check BT-2000 be alive
be_exist=`ps cax | grep -w 'bt2000' | wc -l`
if [ $be_exist -eq 0 ]; then
	# restore env files copy from USB
	if [ -e /dev/sda1 ]; then
		echo '/dev/sda1 exist'
		sudo mount -t vfat /dev/sda1 /mnt
		if [ -e /mnt/envbackup/envbackup.tgz ]; then
			pushd .
			sudo /bin/rm -rf /home/biobase/env_restore
			mkdir /home/biobase/env_restore
			cd /home/biobase/env_restore
			cp /mnt/envbackup/envbackup.tgz .
			tar -zxvf ./envbackup.tgz
			cp -pf ./data/* /home/biobase/data
			cp -pf ./etc/network/interfaces /etc/network/
			cp -pf ./etc/resolvconf/resolv.conf.d/base /etc/resolvconf/resolv.conf.d/
			sudo ifdown eth0
			sudo sudo service network-manager restart
			sudo ifup eth0
			popd
		else
			echo 'usb restore env file not exist'
		fi
		sudo umount /mnt
	else
		echo '/dev/sda1 not exist'
	fi
	# update files copy from USB
	if [ -e /dev/sda1 ]; then
		echo '/dev/sda1 exist'
		sudo mount -t vfat /dev/sda1 /mnt
		if [ -e /mnt/rel.tgz ]; then
			pushd .
			sudo /bin/rm -rf /home/biobase/usb_update
			mkdir /home/biobase/usb_update
			cd /home/biobase/usb_update
			cp -p /mnt/rel.tgz .
			tar -zxvf ./rel.tgz
#			./setup*.sh
			./script/CPUINFO.sh "UDOO_QUAD"
			if [ $? -eq 0 ]; then
				./setup*.sh
			else
				echo "バージョン不一致のため、パッチ適用を中止しました。"
			fi
			sudo sync
			popd
		else
			echo 'usb update file not exist'
		fi
		sudo umount /mnt
	else
		echo '/dev/sda1 not exist'
	fi
	# update files copy from BT-2000 Manager
	if [ -e /home/biobase/data/rel.tgz ]; then
		echo '/home/biobase/data/rel.tgz exist'
		pushd .
		sudo /bin/rm -rf /home/biobase/net_update
		mkdir /home/biobase/net_update
		cd /home/biobase/net_update
		mv ../data/rel.tgz .
		tar -zxvf ./rel.tgz
#		./setup*.sh
		./script/CPUINFO.sh "UDOO_QUAD"
		if [ $? -eq 0 ]; then
			./setup*.sh
			echo "パッチ適用のため、再起動します。"
			sudo sync
			sudo reboot
		else
			echo "バージョン不一致のため、パッチ適用を中止しました。"
			echo "パッチ適用保留モードとして起動します。"
			touch ~/data/PatchPending
		fi
		sudo sync
		popd
	else
		echo 'net update file not exist'
	fi
	# BT-2000 start up
	if [ ! -e /home/biobase/bin/http ]; then
		mkdir -pm 775 /home/biobase/bin/http
		sudo chown biobase /home/biobase/bin/http
		sudo chgrp biobase /home/biobase/bin/http
	fi
	cd /home/biobase/bin
	if [ -e ./core ]; then
		mv ./core ./core.`stat -c '%y' ./core | awk '{print $1 substr($2,1,8)}' | sed -e 's/-//g' | sed -e 's/://g'`
		rm -f `ls -1 ./core.* | head -n -5 | tail -n +6`
	fi
	./mkbootlog.sh > /dev/null 2>&1
	echo BT-2000 boot - `date +%Y/%m/%d%t%H:%M:%S` >> /home/biobase/bt2000boot.log
	ulimit -c unlimited
	export LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:/opt/nec_bioapi/lib"
	cp -p ./LOAD/* .	#cp -pu ./LOAD/* .
	./bt2000monitor >> /home/biobase/bt2000boot.log &
	./bt2000 2> ./out.tmp
	cd ../
else
	echo "The BT-2000 is alive."
fi
